<?php

namespace Mbl\Profile;
add_action( 'mbl_options_tab_3_header_after', 'Mbl\Profile\design_options' );
function design_options(): void {
	?>
    <li><a href="#mbl_inner_tab_3_16"><?php _e( 'Профиль', 'mbl_admin' ) ?></a></li>
	<?php
}

add_action( 'mbl_options_tab_3_content_after', 'Mbl\Profile\design_options_content' );
function design_options_content(): void {
	?>
    <div id="mbl_inner_tab_3_16" class="wpm-tab-content">
		<?php wpm_render_partial( 'options/color-row', 'admin',
			array(
				'label'   => __( 'Цвет рамки полей', 'mbl_admin' ),
				'key'     => 'profile.field_border',
				'default' => 'cccccc'
			) )
		?>
		<?php wpm_render_partial( 'options/color-row', 'admin',
			array(
				'label'   => __( 'Цвет фона полей', 'mbl_admin' ),
				'key'     => 'profile.field_bgc',
				'default' => 'ffffff'
			) )
		?>
		<?php wpm_render_partial( 'options/color-row', 'admin',
			array(
				'label'   => __( 'Цвет текста-подсказок', 'mbl_admin' ),
				'key'     => 'profile.field_placeholder',
				'default' => 'a9a9a9'
			) )
		?>
		<?php wpm_render_partial( 'options/color-row', 'admin',
			array(
				'label'   => __( 'Цвет заполняемого текста', 'mbl_admin' ),
				'key'     => 'profile.field_color',
				'default' => '555555'
			) )
		?>
		<?php wpm_render_partial( 'options/color-row', 'admin',
			array(
				'label'   => __( 'Цвет кнопок', 'mbl_admin' ),
				'key'     => 'profile.btn',
				'default' => 'a0b0a1'
			) )
		?>
		<?php wpm_render_partial( 'options/color-row', 'admin',
			array(
				'label'   => __( 'Цвет кнопок при наведение', 'mbl_admin' ),
				'key'     => 'profile.btn_hover',
				'default' => 'adbead'
			) )
		?>
		<?php wpm_render_partial( 'options/color-row', 'admin',
			array(
				'label'   => __( 'Цвет кнопок при клике', 'mbl_admin' ),
				'key'     => 'profile.btn_active',
				'default' => '8e9f8f'
			) )
		?>
		<?php wpm_render_partial( 'options/color-row', 'admin',
			array(
				'label'   => __( 'Цвет текста кнопок', 'mbl_admin' ),
				'key'     => 'profile.btn_color',
				'default' => 'ffffff'
			) )
		?>
		<?php wpm_render_partial( 'options/color-row', 'admin',
			array(
				'label'   => __( 'Цвет текста кнопок при наведение', 'mbl_admin' ),
				'key'     => 'profile.btn_hover_color',
				'default' => 'ffffff'
			) )
		?>
		<?php wpm_render_partial( 'options/color-row', 'admin',
			array(
				'label'   => __( 'Цвет текста кнопок при клике', 'mbl_admin' ),
				'key'     => 'profile.btn_active_color',
				'default' => 'ffffff'
			) )
		?>
		<?php wpm_render_partial( 'options/color-row', 'admin',
			array(
				'label'   => __( 'Цвет сохранения', 'mbl_admin' ),
				'key'     => 'profile.success_color',
				'default' => 'A0B0A1'
			) )
		?>
		<?php wpm_render_partial( 'options/color-row', 'admin',
			array(
				'label'   => __( 'Цвет ошибки', 'mbl_admin' ),
				'key'     => 'profile.error_color',
				'default' => 'DD3D31'
			) )
		?>
        <div class="wpm-row">
            <div>
                <label for="profile_btn_save_text">
                    Текст кнопки сохранения
                </label>
            </div>
            <input id="profile_btn_save_text" type="text" name="main_options[profile][btn_save_text]"
                   style="width: 99%"
                   placeholder="<?php echo __('Сохранить', 'mbl_admin'); ?>"
                   value="<?= wpm_get_option('profile.btn_save_text', 'Сохранить') ?>">
        </div>
        <div class="wpm-row">
            <div>
                <label for="profile_btn_upload">
                    Текст кнопки загрузки
                </label>
            </div>
            <input id="profile_btn_upload" type="text" name="main_options[profile][btn_upload]"
                   style="width: 99%"
                   placeholder="<?php echo __('Загрузить', 'mbl_admin'); ?>"
                   value="<?= wpm_get_option('profile.btn_upload', 'Загрузить') ?>">
        </div>
        <div class="wpm-row">
            <div>
                <label for="profile_select_file">
                    Выберите файл
                </label>
            </div>
            <input id="profile_select_file" type="text" name="main_options[profile][select_file]"
                   style="width: 99%"
                   placeholder="<?php echo __('Выберите файл', 'mbl_admin'); ?>"
                   value="<?= wpm_get_option('profile.select_file', 'Выберите файл') ?>">
        </div>
        <div class="wpm-row">
            <div>
                <label for="profile_use_image">
                    Использовать изображение
                </label>
            </div>
            <input id="profile_use_image" type="text" name="main_options[profile][use_image]"
                   style="width: 99%"
                   placeholder="<?php echo __('Использовать изображение', 'mbl_admin'); ?>"
                   value="<?= wpm_get_option('profile.use_image', 'Использовать изображение') ?>">
        </div>
        <div class="wpm-row">
            <div>
                <label for="profile_new_pass">
                    Новый пароль
                </label>
            </div>
            <input id="profile_new_pass" type="text" name="main_options[profile][new_pass]"
                   style="width: 99%"
                   placeholder="<?php echo __('Новый пароль', 'mbl_admin'); ?>"
                   value="<?= wpm_get_option('profile.new_pass', 'Новый пароль') ?>">
        </div>
        <div class="wpm-row">
            <div>
                <label for="profile_repeat_pass">
                    Повторить пароль
                </label>
            </div>
            <input id="profile_repeat_pass" type="text" name="main_options[profile][repeat_pass]"
                   style="width: 99%"
                   placeholder="<?php echo __('Повторить пароль', 'mbl_admin'); ?>"
                   value="<?= wpm_get_option('profile.repeat_pass', 'Повторить пароль') ?>">
        </div>
        <div class="wpm-row">
            <div>
                <label for="profile_pass_mismatch">
                    Пароли не совпадают
                </label>
            </div>
            <input id="profile_pass_mismatch" type="text" name="main_options[profile][pass_mismatch]"
                   style="width: 99%"
                   placeholder="<?php echo __('Пароли не совпадают', 'mbl_admin'); ?>"
                   value="<?= wpm_get_option('profile.pass_mismatch', 'Пароли не совпадают') ?>">
        </div>
        <div class="wpm-row">
            <div>
                <label for="profile_saved">
                    Сохранено
                </label>
            </div>
            <input id="profile_saved" type="text" name="main_options[profile][profile_saved]"
                   style="width: 99%"
                   placeholder="<?php echo __('Сохранено', 'mbl_admin'); ?>"
                   value="<?= wpm_get_option('profile.profile_saved', 'Сохранено') ?>">
        </div>
        <div class="wpm-row">
            <div>
                <label for="profile_required">
                    Обязательное поле
                </label>
            </div>
            <input id="profile_required" type="text" name="main_options[profile][profile_required]"
                   style="width: 99%"
                   placeholder="<?php echo __('Обязательное поле', 'mbl_admin'); ?>"
                   value="<?= wpm_get_option('profile.profile_required', 'Обязательное поле') ?>">
        </div>
        <div class="wpm-row">
            <div>
                <label for="invalid_message">
                    Проверьте правильность заполнения
                </label>
            </div>
            <input id="invalid_message" type="text" name="main_options[profile][invalid_message]"
                   style="width: 99%"
                   placeholder="<?php echo __('Проверьте правильность заполнения', 'mbl_admin'); ?>"
                   value="<?= wpm_get_option('profile.invalid_message', 'Проверьте правильность заполнения') ?>">
        </div>
        <div class="wpm-row">
            <div>
                <label for="profile_required">
                    Некорректный email
                </label>
            </div>
            <input id="profile_required" type="text" name="main_options[profile][invalid_email]"
                   style="width: 99%"
                   placeholder="<?php echo __('Некорректный email', 'mbl_admin'); ?>"
                   value="<?= wpm_get_option('profile.invalid_email', 'Некорректный email') ?>">
        </div>
        <div class="wpm-row">
            <div>
                <label for="critical_error">
                    Возникла ошибка. Пожалуйста повторите попытку
                </label>
            </div>
            <input id="critical_error" type="text" name="main_options[profile][critical_error]"
                   style="width: 99%"
                   placeholder="<?php echo __('Возникла ошибка. Пожалуйста повторите попытку', 'mbl_admin'); ?>"
                   value="<?= wpm_get_option('profile.critical_error', 'Возникла ошибка. Пожалуйста повторите попытку') ?>">
        </div>
	    <?php wpm_render_partial('settings-save-button', 'common'); ?>
    </div>
	<?php
}
