(function ($) {
    $(document).ready(form_control)

    function form_control() {
        $('[data-memberlux-profile-form]').on('submit', function (event) {
            event.preventDefault()
            let id = $(this).attr('data-memberlux-profile-form')
            let form = $(this)
            form.find(`[data-validation-error]`).hide()
            form.find('.mblpr-success').hide()
            form.find('.mblpr-error').hide()
            form.find('.mblpr-submit').attr('disabled', 'disabled').addClass('progress-button-active')
            $.ajax({
                url: `${mblpr.rest}v1/mblpr/form/${id}`,
                method: 'POST',
                data: form.serialize(),
                beforeSend: function (xhr) {
                    xhr.setRequestHeader('X-WP-Nonce', mblpr.nonce);
                }
            }).done(function (data) {
                if (data.ok) {
                    form.find('.mblpr-success').show()
                } else {
                    if (data.validation_errors) {
                        for (const field_name in data.validation_errors) {
                            form.find(`[data-validation-error=${field_name}]`)
                                .text(data.validation_errors[field_name].error)
                                .show()
                        }
                    }
                    form.find('.mblpr-error [data-content]').text(data.message)
                    form.find('.mblpr-error').show()
                }
            }).fail(function () {
                form.find('.mblpr-error').text(mblpr.error).show()
            }).always(function () {
                form.find('.mblpr-submit').removeAttr('disabled', '').removeClass('progress-button-active')
            })
        })
        $('[data-memberlux-profile-form]').on('change', function () {
            $(this).find('.mblpr-success').hide()
            $(this).find('.mblpr-error').hide()
        })
        $('[data-memberlux-profile-form]').on('input', function () {
            $(this).find('.mblpr-success').hide()
            $(this).find('.mblpr-error').hide()
        })
        $('[data-memberlux-profile-form]').on('input', 'input', function () {
            let form = $(this).closest('form')
            let field_name = $(this).attr('name')
            form.find(`[data-validation-error=${field_name}]`).hide()
        })
    }

    var wpm_file_frame;
    var image_id = '';
    $(document).on('click', '[data-avatar-upload]', function (event) {
        image_id = $(this).attr('data-id');
        event.preventDefault();
        if (wpm_file_frame) {
            wpm_file_frame.open();
            return;
        }
        wpm_file_frame = wp.media.frames.downloadable_file = wp.media({
            title: mblpr.select_file,
            button: {
                text: mblpr.use_image
            },
            multiple: false
        });
        wpm_file_frame.on('select', function () {
            var attachment = wpm_file_frame.state().get('selection').first().toJSON();
            $('#' + image_id).val(attachment.id);
            $(`[data-avatar=${image_id}]`).find('img').attr('src', attachment.url);
            $(`[data-avatar-upload=${image_id}]`).hide()
            $(`[data-avatar-clear=${image_id}]`).show()
        });
        wpm_file_frame.open();
    });
    $(document).on('click', '[data-avatar-clear]', function () {
        image_id = $(this).attr('data-avatar-clear');
        $(`[data-avatar=${image_id}]`).find('img').attr('src', mblpr.placeholder);
        $('#' + image_id).val('');
        $(`[data-avatar-upload=${image_id}]`).show()
        $(`[data-avatar-clear=${image_id}]`).hide()
    });
})(jQuery)
