<?php

namespace Mbl\Profile;

use WP_Post;
use WP_REST_Request;
use WP_User;

foreach ( get_option( 'mblpr_shortcodes', [] ) as $key => $args ) {
	$tag  = "memberlux_profile_form_$key";
	$$tag = function () use ( $key, $args ) {
        if (!is_user_logged_in()) {
            return  '';
        }
		ob_start();
		$user      = get_user_by( 'id', get_current_user_id() );
		$avatarId = get_user_meta($user->ID, 'avatar', true);
		$hasAvatar = !empty($avatarId);
		$fields    = all_fields();
		$gravatarUrl =  get_avatar_url($user->ID);
		?>
        <form data-memberlux-profile-form="<?= $key ?>" id="memberlux_profile_form_<?= $key ?>"
              class="memberlux_profile_form" style="
                --mblpr-border: <?= '#' . wpm_get_design_option( 'profile.field_border', 'cccccc' ) ?>;
                --mblpr-bgc: <?= '#' . wpm_get_design_option( 'profile.field_bgc', 'ffffff' ) ?>;
                --mblpr-placeholder: <?= '#' . wpm_get_design_option( 'profile.field_placeholder', 'a9a9a9' ) ?>;
                --mblpr-success_color: <?= '#' . wpm_get_design_option( 'profile.success_color', 'A0B0A1' ) ?>;
                --mblpr-error-color: <?= '#' . wpm_get_design_option( 'profile.error_color', 'DD3D31' ) ?>;
                --mblpr-color: <?= '#' . wpm_get_design_option( 'profile.field_color', '555555' ) ?>;
                --mblpr-btn: <?= '#' . wpm_get_design_option( 'profile.btn', 'a0b0a1' ) ?>;
                --mblpr-btn-hover: <?= '#' . wpm_get_design_option( 'profile.btn_hover', 'adbead' ) ?>;
                --mblpr-btn-active: <?= '#' . wpm_get_design_option( 'profile.btn_active', '8e9f8f' ) ?>;
                --mblpr-btn-color: <?= '#' . wpm_get_design_option( 'profile.btn_color', 'ffffff' ) ?>;
                --mblpr-btn-color-hover: <?= '#' . wpm_get_design_option( 'profile.btn_hover_color', 'ffffff' ) ?>;
                --mblpr-btn-color-active: <?= '#' . wpm_get_design_option( 'profile.btn_active_color', 'ffffff' ) ?>;
                ">
            <div class="mblpr_fields">
				<?php foreach ( $args['order'] as $field_name ): ?>
					<?php if ( $field_name === 'avatar' ): ?>
                        <div class="mblpr_field_group"
                             data-avatar="mblpr_field_<?= $field_name ?>_<?= $key ?>"
                        >
                            <label for="mblpr_field_<?= $field_name ?>_<?= $key ?>" style="display: none">
								<?= $args[ $field_name ]['label'] ?: $fields[ $field_name ]['label'] ?><?=
								$args[ $field_name ]['required'] == 1 ? ' *' : '' ?>
                            </label>
                            <input type="hidden" id="mblpr_field_<?= $field_name ?>_<?= $key ?>"
                                   name="avatar"
                                   value="<?= $avatarId ?? '' ?>"
                                   class="wide">
                            <div class="mblpr-input-wrap">
                                <div class="mblpr-avatar-preview-wrap">
                                    <div class="mblpr-avatar-preview-box">
                                        <img src="<?= $hasAvatar
											? wp_get_attachment_image_url($avatarId)
											: $gravatarUrl ?>"
                                             height="96" width="96" alt="<?= $user->display_name ?>">
                                    </div>
                                </div>
                                <div class="wpm-control-row">
                                    <div>
                                        <button data-avatar-upload="mblpr_field_<?= $field_name ?>_<?= $key ?>"
                                                type="button" class=""
                                                data-id="mblpr_field_<?= $field_name ?>_<?= $key ?>">
											<?= wpm_get_option( 'profile.btn_upload', 'Загрузить' ) ?>
                                        </button>
                                        &nbsp;&nbsp;
                                        <button type="button"
                                                data-avatar-clear="mblpr_field_<?= $field_name ?>_<?= $key ?>"
                                                class=""
                                                data-id="avatar"
											<?php if ( ! $hasAvatar ) {
												echo 'style="display:none"';
											} ?>>
                                            <span class="fa fa-trash"></span>
                                        </button>
                                    </div>
                                </div>
                            </div>
                            <p class="mblpr-validation-error" style="display: none"
                               data-validation-error="<?= $field_name ?>"></p>
                        </div>
					<?php elseif ( $field_name === 'display_name' ): ?>
                        <div class="mblpr_field_group">
                            <label for="mblpr_field_<?= $field_name ?>_<?= $key ?>">
								<?= $args[ $field_name ]['label'] ?: $fields[ $field_name ]['label'] ?><?=
								$args[ $field_name ]['required'] == 1 ? ' *' : '' ?>
                            </label>
                            <div class="mblpr-input-wrap">
                                <select class="mblpr-field"
                                        name="display_name"
                                        id="mblpr_field_<?= $field_name ?>_<?= $key ?>">
									<?php
									$public_display                     = array();
									$public_display['display_nickname'] = $user->nickname;
									$public_display['display_username'] = $user->user_login;

									if ( ! empty( $user->first_name ) ) {
										$public_display['display_firstname'] = $user->first_name;
									}

									if ( ! empty( $user->last_name ) ) {
										$public_display['display_lastname'] = $user->last_name;
									}

									if ( ! empty( $user->first_name ) && ! empty( $user->last_name ) ) {
										$public_display['display_firstlast'] = $user->first_name . ' ' . $user->last_name;
										$public_display['display_lastfirst'] = $user->last_name . ' ' . $user->first_name;
									}

									if ( ! in_array( $user->display_name, $public_display, true ) ) { // Only add this if it isn't duplicated elsewhere.
										$public_display = array( 'display_displayname' => $user->display_name ) + $public_display;
									}

									$public_display = array_map( 'trim', $public_display );
									$public_display = array_unique( $public_display );

									?>
									<?php foreach ( $public_display as $id => $item ) : ?>
                                        <option <?php selected( $user->display_name, $item ); ?>><?php echo $item; ?></option>
									<?php endforeach; ?>
                                </select>
                            </div>
                            <p class="mblpr-validation-error" style="display: none"
                               data-validation-error="<?= $field_name ?>"></p>
                        </div>
					<?php elseif ( $field_name === 'user_pass' ): ?>
                        <div class="mblpr_field_group">
                            <label for="mblpr_field_<?= $field_name ?>_<?= $key ?>" style="display: none">
								<?= $args[ $field_name ]['label'] ?: $fields[ $field_name ]['label'] ?><?=
								$args[ $field_name ]['required'] == 1 ? ' *' : '' ?>
                            </label>
                            <div class="mblpr-input-wrap">
								<?php if ( ! empty( $args[ $field_name ]['icon'] ) ): ?>
                                    <span class="mblpr-icon fa <?= $args[ $field_name ]['icon'] ?>"></span>
								<?php endif; ?>
                                <input class="mblpr-field<?=
								! empty( $args[ $field_name ]['icon'] ) ? ' mblpr-field--with-icon' : '' ?>"
                                       placeholder="<?= $args[ $field_name ]['label'] ?: $fields[ $field_name ]['label'] ?>"
                                       id="mblpr_field_<?= $field_name ?>_<?= $key ?>"
									<?= $args[ $field_name ]['required'] == 1 ? 'required' : '' ?>
                                       autocomplete="new-password"
                                       type="password" value="" name="<?= $field_name ?>">
                            </div>
                            <p class="mblpr-validation-error" style="display: none"
                               data-validation-error="<?= $field_name ?>"></p>
                        </div>
                        <div class="mblpr_field_group">
                            <label for="mblpr_field_<?= $field_name ?>_repeat_<?= $key ?>" style="display: none">
								<?= wpm_get_option( 'profile.repeat_pass', 'Повторить пароль' ) ?>
                            </label>
                            <div class="mblpr-input-wrap">
								<?php if ( ! empty( $args[ $field_name ]['icon'] ) ): ?>
                                    <span class="mblpr-icon fa <?= $args[ $field_name ]['icon'] ?>"></span>
								<?php endif; ?>
                                <input class="mblpr-field<?=
								! empty( $args[ $field_name ]['icon'] ) ? ' mblpr-field--with-icon' : '' ?>"
                                       id="mblpr_field_<?= $field_name ?>_repeat_<?= $key ?>"
                                       placeholder="<?= wpm_get_option( 'profile.repeat_pass', 'Повторить пароль' ) ?>"
                                       autocomplete="new-password"
                                       type="password" value="" name="<?= $field_name ?>_repeat">
                            </div>
                            <p class="mblpr-validation-error" style="display: none"
                               data-validation-error="<?= $field_name ?>_repeat"></p>
                        </div>
					<?php elseif ( $field_name === 'custom1textarea' ): ?>
                        <div class="mblpr_field_group">
                            <label for="mblpr_field_<?= $field_name ?>_<?= $key ?>" style="display: none">
								<?= $args[ $field_name ]['label'] ?: $fields[ $field_name ]['label'] ?><?=
								$args[ $field_name ]['required'] == 1 ? ' *' : ''
								?>
                            </label>
                            <div class="mblpr-input-wrap">
								<?php if ( ! empty( $args[ $field_name ]['icon'] ) ): ?>
                                    <span class="mblpr-icon fa <?= $args[ $field_name ]['icon'] ?>"></span>
								<?php endif; ?>
                                <textarea name="<?= $field_name ?>"
                                          placeholder="<?= $args[ $field_name ]['label'] ?: $fields[ $field_name ]['label'] ?>"
                                          id="mblpr_field_<?= $field_name ?>_<?= $key ?>"
                                          class="mblpr-textarea mblpr-field<?=
								          ! empty( $args[ $field_name ]['icon'] ) ? ' mblpr-field--with-icon' : '' ?>"
                                          cols="30" rows="10"><?=
									field_value( $user, $field_name )
									?></textarea>
                            </div>
                            <p class="mblpr-validation-error" style="display: none"
                               data-validation-error="<?= $field_name ?>"></p>
                        </div>
					<?php else: ?>
                        <div class="mblpr_field_group">
                            <label for="mblpr_field_<?= $field_name ?>_<?= $key ?>" style="display: none">
								<?= $args[ $field_name ]['label'] ?: $fields[ $field_name ]['label'] ?><?php
								if ( in_array( $field_name, [ 'user_email', 'user_nicename' ] ) ) {
									echo ' *';
								} else {
									echo $args[ $field_name ]['required'] == 1 ? ' *' : '';
								}
								?>
                            </label>
                            <div class="mblpr-input-wrap">
								<?php if ( ! empty( $args[ $field_name ]['icon'] ) ): ?>
                                    <span class="mblpr-icon fa <?= $args[ $field_name ]['icon'] ?>"></span>
								<?php endif; ?>
                                <input class="mblpr-field<?=
								! empty( $args[ $field_name ]['icon'] ) ? ' mblpr-field--with-icon' : '' ?>"
                                       placeholder="<?= $args[ $field_name ]['label'] ?: $fields[ $field_name ]['label'] ?>"
                                       id="mblpr_field_<?= $field_name ?>_<?= $key ?>"
                                       type="text"
                                       value="<?= field_value( $user, $field_name ) ?>"
                                       name="<?= $field_name ?>">
                            </div>
                            <p class="mblpr-validation-error" style="display: none"
                               data-validation-error="<?= $field_name ?>"></p>
                        </div>
					<?php endif; ?>
				<?php endforeach; ?>
            </div>
            <div class="mblpr-success" style="display: none">
                <span class="fa fa-check-circle-o"></span>&nbsp<span data-content>
                    <?= wpm_get_option( 'profile.profile_saved', 'Сохранено' ) ?>
                </span>
            </div>
            <div class="mblpr-error" style="display: none">
                <span class="fa fa-exclamation-circle"></span>&nbsp<span data-content></span>
            </div>
            <button class="mblpr-submit mbr-btn" type="submit">
				<?= wpm_get_option( 'profile.btn_save_text', 'Сохранить' ) ?>
            </button>
        </form>
		<?php
		return preg_replace( [ '/>\s+/', '/\s+</', '/(\s)+/' ], [ '>', '<', '\\1' ], ob_get_clean() );
	};
	add_shortcode( $tag, $$tag );
}

add_action( 'admin_enqueue_scripts', 'Mbl\Profile\shortcodes_enqueue_scripts' );
add_action( 'wp_enqueue_scripts', 'Mbl\Profile\shortcodes_enqueue_scripts' );
function shortcodes_enqueue_scripts(): void {
    $post = get_queried_object();
    if (!($post instanceof WP_Post)) {
        return;
    }
    $shortcodes = get_option('mblpr_shortcodes', []);
    if (empty($shortcodes)) {
     return;
    }
    $has_shortcode = false;
    foreach ($shortcodes as $key => $args) {
        if (has_shortcode($post->post_content, "memberlux_profile_form_$key")) {
            $has_shortcode = true;
            break;
        }
    }
    if (!$has_shortcode) {
        return;
    }
	wp_enqueue_media();
	wp_enqueue_script(
		'mblpr-forms',
		MBLPR_PLUGIN_URI . 'js/mblpr-forms.js',
		[ 'jquery' ],
		MBLPR_VERSION
	);
	wp_localize_script( 'mblpr-forms', 'mblpr', [
		'placeholder' => MBLPR_PLUGIN_URI . 'css/b54e08c83a2e13b8151dd075d57824f3.png',
		'rest'        => rest_url(),
		'nonce'       => wp_create_nonce( 'wp_rest' ),
		'error'       => wpm_get_option( 'profile.critical_error', 'Возникла ошибка. Пожалуйста повторите попытку' ),
		'select_file' => wpm_get_option( 'profile.select_file', 'Выберите файл' ),
		'use_image'   => wpm_get_option( 'profile.use_image', 'Использовать изображение' ),
	] );
	wp_enqueue_style(
		'mblpr-forms',
		MBLPR_PLUGIN_URI . 'css/mblpr-forms.css',
		[],
		MBLPR_VERSION
	);
}

add_action( 'rest_api_init', 'Mbl\Profile\rest_api_init_action' );
function rest_api_init_action() {
    register_rest_route( 'v1/mblpr', '/form/(?P<id>\d+)', [
        'methods'             => 'POST',
        'callback'            => 'Mbl\Profile\form_handler',
        'permission_callback' => fn() => is_user_logged_in(),
    ] );
}

function form_handler( WP_REST_Request $request ): array {
	$user_id = get_current_user_id();
	$id      = (int) $request->get_param( 'id' );
	$forms   = get_option( 'mblpr_shortcodes', [] );
	if ( isset( $forms[ $id ] ) ) {
		$form              = $forms[ $id ];
		$validation_errors = [];
		foreach ( $form['order'] as $field_name ) {
			$value = trim( $_POST[ $field_name ] );
			if ( (int) $form[ $field_name ]['required'] === 1 || in_array( $field_name, [
					'user_email',
					'user_nicename'
				] ) ) {
				if ( empty( $value ) ) {
					$validation_errors[ $field_name ] = [ 'error' => wpm_get_option( 'profile.profile_required', 'Обязательное поле' ) ];
				}
			}
			if ( ! isset( $validation_errors[ $field_name ] ) ) {
				if ( $field_name === 'user_email' && ! is_email( $value ) ) {
					$validation_errors[ $field_name ] = [ 'error' => wpm_get_option( 'profile.invalid_email', 'Некорректный email' ) ];
				}
			}
			if ( $field_name === 'user_pass' && $value !== trim( $_POST['user_pass_repeat'] ) ) {
				$validation_errors['user_pass_repeat'] = [ 'error' => wpm_get_option( 'profile.pass_mismatch', 'Пароли не совпадают' ) ];
			}
		}
		if ( ! empty( $validation_errors ) ) {
			$response = [
				'ok'                => false,
				'message'           => wpm_get_option( 'profile.invalid_message', 'Проверьте правильность заполнения' ),
				'validation_errors' => $validation_errors
			];
		} else {
			$userdata    = [];
			$meta_fields = [];
			$user_fields = [
				'user_url',
				'user_pass',
				'user_nicename',
				'user_email',
				'display_name',
				'user_nicename',
				'first_name',
				'last_name',
				'user_pass'
			];
			foreach ( $_POST as $field_name => $_value ) {
				$value = trim( $_value );
				if ( in_array( $field_name, $user_fields ) ) {
					if ( $field_name === 'user_pass' && empty( $value ) ) {
						continue;
					}
					$userdata[ $field_name ] = $value;
				} else {
					if ( $field_name === 'user_pass_repeat' ) {
						continue;
					}
					$meta_fields[ $field_name ] = $value;
				}
			}
			if ( ! empty( $meta_fields ) ) {
				foreach ( $meta_fields as $field_name => $value ) {
					update_user_meta( $user_id, $field_name, $value );
				}
			}
			$userdata['ID'] = $user_id;
			wp_update_user( $userdata );
			$response = [ 'ok' => true ];
		}
	} else {
		$response = [
			'ok'      => false,
			'message' => wpm_get_option(
				'profile.critical_error',
				'Возникла ошибка. Пожалуйста повторите попытку'
			)
		];
	}

	return $response;
}

function field_value( WP_User $user, string $field_name ) {
	$map = [
		'first_name'      => fn() => $user->first_name,
		'last_name'       => fn() => $user->last_name,
		'surname'         => fn() => get_user_meta( $user->ID, 'surname', true ),
		'user_nicename'   => fn() => $user->user_nicename,
		'display_name'    => fn() => $user->display_name,
		'user_email'      => fn() => $user->user_email,
		'user_url'        => fn() => $user->user_url,
		'phone'           => fn() => get_user_meta( $user->ID, 'phone', true ),
		'avatar'          => fn() => get_user_meta( $user->ID, 'avatar', true ),
		'user_pass'       => fn() => '',
		'chat_id'         => fn() => get_user_meta( $user->ID, 'chat_id', true ),
		'custom1textarea' => fn() => get_user_meta( $user->ID, 'custom1textarea', true )
	];
	foreach ( range( 1, 10 ) as $item ) {
		$key         = "custom{$item}";
		$map[ $key ] = fn() => get_user_meta( $user->ID, $key, true );
	}

	return $map[ $field_name ]();
}
